import numpy as np
import matplotlib.pyplot as plt
import sympy as sym
import math
import os
import subprocess
import fileinput
import re
import matlab.engine
from HelperFunctions import *
from ClassifyMin import *
# from mpl_toolkits.mplot3d import axes3d
from mpl_toolkits import mplot3d

import matplotlib.ticker as ticker
# from subprocess import Popen, PIPE
#import sys

###################### makePlot.py #########################
#  Generalized Plot-Script giving the option to define
#  quantity of interest and the parameter it depends on
#  to create a plot
#
#  Input: Define y & x for "x-y plot" as Strings
#  - Run the 'Cell-Problem' for the different Parameter-Points
#  (alternatively run 'Compute_MuGamma' if quantity of interest
#   is q3=muGamma for a significant Speedup)

###########################################################

def format_func(value, tick_number):
    # find number of multiples of pi/2
    N = int(np.round(2 * value / np.pi))
    if N == 0:
        return "0"
    elif N == 1:
        return r"$\pi/2$"
    elif N == 2:
        return r"$\pi$"
    elif N % 2 > 0:
        return r"${0}\pi/2$".format(N)
    else:
        return r"${0}\pi$".format(N // 2)





def find_nearest(array, value):
    array = np.asarray(array)
    idx = (np.abs(array - value)).argmin()
    return array[idx]


def find_nearestIdx(array, value):
    array = np.asarray(array)
    idx = (np.abs(array - value)).argmin()
    return idx



# TODO
# - Fallunterscheidung (Speedup) falls gesuchter value mu_gamma = q3
# - Also Add option to plot Minimization Output


# ----- Setup Paths -----
InputFile  = "/inputs/cellsolver.parset"
OutputFile = "/outputs/output.txt"
# path = os.getcwd()
# InputFilePath = os.getcwd()+InputFile
# OutputFilePath = os.getcwd()+OutputFile
# --------- Run  from src folder:
path_parent = os.path.dirname(os.getcwd())
os.chdir(path_parent)
path = os.getcwd()
print(path)
InputFilePath = os.getcwd()+InputFile
OutputFilePath = os.getcwd()+OutputFile
print("InputFilepath: ", InputFilePath)
print("OutputFilepath: ", OutputFilePath)
print("Path: ", path)

#---------------------------------------------------------------

print('---- Input parameters: -----')
# mu1 = 10.0
# # lambda1 = 10.0
# rho1 = 1.0
# alpha = 5.0
# beta = 10.0
# theta = 1.0/4.0


mu1 = 10.0
# lambda1 = 10.0
rho1 = 1.0
alpha = 5.0
beta = 2.0
theta = 1.0/4.0
# theta = 1.0/12.0


lambda1 = 0.0
gamma = 1.0/4.0

gamma = 'infinity'
gamma = '0'


print('mu1: ', mu1)
print('rho1: ', rho1)
print('alpha: ', alpha)
print('beta: ', beta)
print('theta: ', theta)
print('gamma:', gamma)
print('----------------------------')



# TODO? : Ask User for Input ...
# function = input("Enter value you want to plot (y-value):\n")
# print(f'You entered {function}')
# parameter = input("Enter Parameter this value depends on (x-value) :\n")
# print(f'You entered {parameter}')

# Add Option to change NumberOfElements used for computation of Cell-Problem


# --- Define Quantity of interest:
# Options: 'q1', 'q2', 'q3', 'q12' ,'q21', 'q31', 'q13' , 'q23', 'q32' , 'b1', 'b2' ,'b3'
# TODO: EXTRA (MInimization Output) 'Minimizer (norm?)' 'angle', 'type', 'curvature'
# yName = 'q12'
# # yName = 'b1'
# yName = 'q3'
yName = 'angle'
# yName = 'curvature'


xName = 'theta'
xName = 'alpha'


# --- define Interval of x-values:
xmin = 2
xmax = 6


numPoints = 400
X_Values = np.linspace(xmin, xmax, num=numPoints)
print(X_Values)


Y_Values = []

SamplePoints_2D = 20

prestrain_b1Vec = np.vectorize(prestrain_b1)
prestrain_b2Vec = np.vectorize(prestrain_b2)


alphas_ = np.linspace(-20, 20, SamplePoints_2D)
thetas_ = np.linspace(0.01,0.99,SamplePoints_2D)
#fix to one value:
betas_ = 2.0;
alphas, betas, thetas = np.meshgrid(alphas_, betas_, thetas_, indexing='ij')

B1 = prestrain_b1Vec(rho1, betas, alphas, thetas)
B2 = prestrain_b2Vec(rho1, betas, alphas, thetas)
print('B1:', B1)

B1 = np.array(B1)  #convert the np array
B2 = np.array(B2)



f,ax=plt.subplots(1)

ax.plot(thetas, B1)
ax.scatter(thetas, B1)


plt.xlabel("$q_3$")
plt.xlabel("$\gamma$")
plt.ylabel("angle")
ax.grid(True)


# ax.yaxis.set_major_locator(plt.MultipleLocator(np.pi / 2))
# ax.yaxis.set_minor_locator(plt.MultipleLocator(np.pi / 12))

# ax.yaxis.set_major_locator(plt.MultipleLocator(np.pi / 4))
# ax.yaxis.set_minor_locator(plt.MultipleLocator(np.pi / 12))
# ax.yaxis.set_major_formatter(plt.FuncFormatter(format_func))

# ax.yaxis.set_major_formatter(ticker.FormatStrFormatter('%g $\pi$'))
# ax.yaxis.set_major_locator(ticker.MultipleLocator(base=0.25))


# ax.yaxis.set_major_formatter(ticker.FuncFormatter(
# lambda val,pos: '{:.0g}$\pi$'.format(2*val/np.pi) if val !=0 else '0'))
# ax.yaxis.set_major_locator(ticker.MultipleLocator(base=0.5*np.pi))

# ---------------------------- show pi values ------------------------------------
# ax.axvline(x = q1, color = 'b', linestyle = ':', label='$q_1$')
# ax.axvline(x = q2, color = 'r', linestyle = 'dashed', label='$q_2$')
# ax.legend()
# # ax.set(xlim=(1.750, 1.880), ylim=(0, math.pi/2.0))
# ax.set(xlim=(1.760, 1.880), ylim=(-0.1, np.pi/4.0))
# # ax.set_yticks([0,  np.pi/4 ,np.pi/2])
# # labels = ['$0$', r'$\pi/4$', r'$\pi/2$']
# ax.set_yticks([0, np.pi/8, np.pi/4 ])
# labels = ['$0$',r'$\pi/8$', r'$\pi/4$']
# ax.set_yticklabels(labels)
# ---------------------------------------------------------------

ax.legend()
# ax.set(xlim=(1.750, 1.880), ylim=(0, math.pi/2.0))

# ax.set(xlim=(1.760, 1.880), ylim=(-0.1, np.pi/4.0))
# ax.set(xlim=(1.760, 1.880), ylim=(-0.1, np.pi/4.0))
# ax.set_yticks([0,  np.pi/4 ,np.pi/2])
# labels = ['$0$', r'$\pi/4$', r'$\pi/2$']
ax.set_yticks([0, np.pi/8, np.pi/4 ])
labels = ['$0$',r'$\pi/8$', r'$\pi/4$']
ax.set_yticklabels(labels)


# Plot Gamma Value that is closest to q3_star
ax.axvline(x = gammaClose, color = 'b', linestyle = 'dashed', label='$\gamma^*$')
ax.axvspan(gamma_min, gammaClose, color='red', alpha=0.5)
ax.axvspan(gammaClose, gamma_max, color='green', alpha=0.5)




# plt.xlabel("$q_3(\gamma)$")
plt.xlabel("$\gamma$")
plt.ylabel("angle")
plt.legend(loc='upper center')

plt.show()

















#
# fig = plt.figure(figsize=(14,6))
#
# # `ax` is a 3D-aware axis instance because of the projection='3d' keyword argument to add_subplot
# ax = fig.add_subplot(1, 2, 1, projection='3d')
#
# p = ax.plot_surface(alphas, thetas, B1, rstride=4, cstride=4, linewidth=0)
#
# # surface_plot with color grading and color bar
# ax = fig.add_subplot(1, 2, 2, projection='3d')
# p = ax.plot_surface(alphas, thetas, B1, rstride=1, cstride=1, cmap=matplotlib.cm.coolwarm, linewidth=0, antialiased=False)
# cb = fig.colorbar(p, shrink=0.5)
#
#
#
# fig = plt.figure()
# ax = plt.axes(projection='3d')
#
# # fig = plt.figure(figsize=(6,6))
# # ax = fig.add_subplot(111, projection='3d')
# ax = fig.add_subplot(111)
#
# # f,ax=plt.subplots(1)
#
# # Plot a 3D surface
# # ax.plot_surface(alphas, thetas, B1,cmap='viridis', edgecolor='none')
# # ax.plot_surface(alphas, thetas, B1)
# # ax.plot_surface(alphas, thetas, B1)
#
# ax.plot3D(alphas, thetas, B1, 'gray')
# # ax = fig.add_subplot(211, projection='3d')
# #
# #
# # # Plot a 3D surface
# # ax.plot_surface(alphas, thetas, B1)
#
# plt.show()

# fig = plt.figure()
# ax = fig.add_subplot(111, projection='3d')
# colors = cm.plasma(Types)
# # if make_2D_plot: pnt3d=ax.scatter(alphas,thetas,c=Types.flat)
# # if make_3D_plot: pnt3d=ax.scatter(alphas,betas,thetas,c=Types.flat)
# if make_2D_plot: pnt3d=ax.scatter(alphas,thetas,c=angles.flat)
# if make_3D_plot: pnt3d=ax.scatter(alphas,betas,thetas,c=angles.flat)
# # cbar=plt.colorbar(pnt3d)
# # cbar.set_label("Values (units)")
# plt.axvline(x = 8, color = 'b', linestyle = ':', label='$q_1$')
# plt.axhline(y = 0.083333333, color = 'b', linestyle = ':', label='$q_1$')
#
# ax.set_xlabel('alpha')
# ax.set_ylabel('beta')
# if make_3D_plot: ax.set_zlabel('theta')
# plt.show()


#
#
# # for theta in X_Values:
# for alpha in X_Values:
#
#     print('Situation of Lemma1.4')
#     q12 = 0.0
#     q1 = (1.0/6.0)*harmonicMean(mu1, beta, theta)
#     q2 = (1.0/6.0)*arithmeticMean(mu1, beta, theta)
#     b1 = prestrain_b1(rho1, beta, alpha,theta)
#     b2 = prestrain_b2(rho1, beta, alpha,theta)
#     b3 = 0.0
#     if gamma == '0':
#         q3 = q2
#     if gamma == 'infinity':
#         q3 = q1
#
#     if yName == 'q1':                   # TODO: Better use dictionary?...
#         print('q1 used')
#         Y_Values.append(q1)
#     elif yName =='q2':
#         print('q2 used')
#         Y_Values.append(q2)
#     elif yName =='q3':
#         print('q3 used')
#         Y_Values.append(q3)
#     elif yName =='q12':
#         print('q12 used')
#         Y_Values.append(q12)
#     elif yName =='b1':
#         print('b1 used')
#         Y_Values.append(b1)
#     elif yName =='b2':
#         print('b2 used')
#         Y_Values.append(b2)
#     elif yName =='b3':
#         print('b3 used')
#         Y_Values.append(b3)
#     elif yName == 'angle' or yName =='type' or yName =='curvature':
#         G, angle, Type, curvature = classifyMin_ana(alpha,beta,theta, q3,  mu1, rho1)
#         if yName =='angle':
#             print('angle used')
#             Y_Values.append(angle)
#         if yName =='type':
#             print('angle used')
#             Y_Values.append(type)
#         if yName =='curvature':
#             print('angle used')
#             Y_Values.append(curvature)
#
#
# print("(Output) Values of " + yName + ": ", Y_Values)
#
#
# idx = find_nearestIdx(Y_Values, 0)
# print(' Idx of value  closest to 0', idx)
# ValueClose = Y_Values[idx]
# print('GammaValue(Idx) with mu_gamma closest to q_3^*', ValueClose)
#
#
#
# # Find Indices where the difference between the next one is larger than epsilon...
# jump_idx = []
# jump_xValues = []
# jump_yValues = []
# tmp = X_Values[0]
# for idx, x in enumerate(X_Values):
#     print(idx, x)
#     if idx > 0:
#         if abs(Y_Values[idx]-Y_Values[idx-1]) > 1:
#             print('jump candidate')
#             jump_idx.append(idx)
#             jump_xValues.append(x)
#             jump_yValues.append(Y_Values[idx])
#
#
#
#
#
#
#
# print("Jump Indices", jump_idx)
# print("Jump X-values:", jump_xValues)
# print("Jump Y-values:", jump_yValues)
#
# y_plotValues = [Y_Values[0]]
# x_plotValues = [X_Values[0]]
# # y_plotValues.extend(jump_yValues)
# for i in jump_idx:
#     y_plotValues.extend([Y_Values[i-1], Y_Values[i]])
#     x_plotValues.extend([X_Values[i-1], X_Values[i]])
#
#
# y_plotValues.append(Y_Values[-1])
# # x_plotValues = [X_Values[0]]
# # x_plotValues.extend(jump_xValues)
# x_plotValues.append(X_Values[-1])
#
#
# print("y_plotValues:", y_plotValues)
# print("x_plotValues:", x_plotValues)
# # Y_Values[np.diff(y) >= 0.5] = np.nan
#
#
# #get values bigger than jump position
# x_rest = X_Values[X_Values>x_plotValues[1]]
#
# Y_Values = np.array(Y_Values)  #convert the np array
#
# y_rest = Y_Values[X_Values>x_plotValues[1]]
# # y_rest = Y_Values[np.nonzero(X_Values>x_plotValues[1]]
# print('X_Values:', X_Values)
# print('Y_Values:', Y_Values)
# print('x_rest:', x_rest)
# print('y_rest:', y_rest)
# print('np.nonzero(X_Values>x_plotValues[1]', np.nonzero(X_Values>x_plotValues[1]) )
#
#
# # ---------------- Create Plot -------------------
# plt.figure()
#
# f,ax=plt.subplots(1)
#
# # plt.title(r''+ yName + '-Plot')
# # plt.plot(X_Values, Y_Values,linewidth=2, '.k')
# # plt.plot(X_Values, Y_Values,'.k',markersize=1)
# # plt.plot(X_Values, Y_Values,'.',markersize=0.8)
#
# # plt.plot(X_Values, Y_Values)
#
# # ax.plot([[0],X_Values[-1]], [Y_Values[0],Y_Values[-1]])
# # ax.plot([x_plotValues[0],x_plotValues[1]], [y_plotValues[0],y_plotValues[1]] , 'b')
# # ax.plot(x_rest, y_rest, 'b')
#
#
#
# ax.plot(X_Values, Y_Values)
#
# # plt.plot(x_plotValues, y_plotValues,'.')
# # plt.scatter(X_Values, Y_Values, alpha=0.3)
# # plt.scatter(X_Values, Y_Values)
# # plt.plot(X_Values, Y_Values,'.')
# # plt.plot([X_Values[0],X_Values[-1]], [Y_Values[0],Y_Values[-1]])
# # plt.axis([0, 6, 0, 20])
#
# plt.xlabel(xName)
# plt.ylabel(yName)
#
# # plt.ylabel('$\kappa$')
#
# # ax.yaxis.set_major_formatter(ticker.FormatStrFormatter('%g $\pi$'))
# # ax.yaxis.set_major_locator(ticker.MultipleLocator(base=0.1))
#
# ax.grid(True)
# ax.yaxis.set_major_locator(plt.MultipleLocator(np.pi / 2))
# ax.yaxis.set_minor_locator(plt.MultipleLocator(np.pi / 12))
#
# ax.yaxis.set_major_formatter(plt.FuncFormatter(format_func))
#
# # Plot every other line.. not the jumps...
# tmp = 1
# # for idx, x in enumerate(x_plotValues):
# #     if idx > 0 and tmp == 1:
# #         # plt.plot([x_plotValues[idx-1],x_plotValues[idx]] ,[y_plotValues[idx-1],y_plotValues[idx]] )
# #         ax.plot([x_plotValues[idx-1],x_plotValues[idx]] ,[y_plotValues[idx-1],y_plotValues[idx]] )
# #         tmp = 0
# #     else:
# #         tmp = 1
#
# # plt.plot([x_plotValues[0],x_plotValues[1]] ,[y_plotValues[0],y_plotValues[1]] )
# # plt.plot([x_plotValues[2],x_plotValues[3]] ,[y_plotValues[2],y_plotValues[3]] )
# # plt.plot([x_plotValues[4],x_plotValues[5]] ,[y_plotValues[4],y_plotValues[5]] )
# # plt.plot([x_plotValues[6],x_plotValues[7]] ,[y_plotValues[6],y_plotValues[7]] )
#
#
# for x in jump_xValues:
#     plt.axvline(x,ymin=0, ymax= 1, color = 'g',alpha=0.5, linestyle = 'dashed')
#
# # plt.axvline(x_plotValues[1],ymin=0, ymax= 1, color = 'g',alpha=0.5, linestyle = 'dashed')
#
# # plt.axhline(y = 1.90476, color = 'b', linestyle = ':', label='$q_1$')
# # plt.axhline(y = 2.08333, color = 'r', linestyle = 'dashed', label='$q_2$')
# # plt.legend()
# plt.show()
# #---------------------------------------------------------------
