import numpy as np
import matplotlib.pyplot as plt
import sympy as sym
import math
import os
import subprocess
import fileinput
import re
import matlab.engine
# from subprocess import Popen, PIPE
#import sys

###################### Plotq12.py #########################
#  Input: Lame-Parameter Lambda
#  compute q12 entry of Q_hom for each Lambda
#  create plot:  q12(lambda)
###########################################################


InputFile  = "/inputs/cellsolver.parset"
OutputFile = "/outputs/output.txt"
# path = os.getcwd()
# InputFilePath = os.getcwd()+InputFile
# OutputFilePath = os.getcwd()+OutputFile
# --------- Run  from src folder:
path_parent = os.path.dirname(os.getcwd())
os.chdir(path_parent)
path = os.getcwd()
print(path)
InputFilePath = os.getcwd()+InputFile
OutputFilePath = os.getcwd()+OutputFile
print("InputFilepath: ", InputFilePath)
print("OutputFilepath: ", OutputFilePath)
print("Path: ", path)

#---------------------------------------------------------------
Lambda_Values = np.linspace(0.0, 10.0, num=10)
print(Lambda_Values)
q12 = []


# --- Options
RUN = True
# RUN = False
# make_Plot = False
make_Plot = True      # vll besser : Plot_muGamma

if RUN:
    for lambda1 in Lambda_Values:
        print("Run Cell-Problem for Lambda = ", lambda1)
        # print('gamma='+str(gamma))
        with open(InputFilePath, 'r') as file:
            filedata = file.read()
        filedata = re.sub('(?m)^lambda1=.*','lambda1='+str(lambda1),filedata)
        f = open(InputFilePath,'w')
        f.write(filedata)
        f.close()
        # Run Cell-Problem
        subprocess.run(['./build-cmake/src/dune-microstructure', './inputs/cellsolver.parset'],
                                             capture_output=True, text=True)
        #Extract mu_gamma from Output-File
        with open(OutputFilePath, 'r') as file:
            output = file.read()
        tmp = re.search(r'(?m)^q_onetwo=.*',output).group()
        s = re.findall(r"[-+]?\d*\.\d+|\d+", tmp)
        q12Value = float(s[0])
        print("q12:", q12Value)
        q12.append(q12Value)
    # ------------end of for-loop -----------------
    print("(Output) Values of q12: ", q12)
# ----------------end of if-statement -------------


# Make Plot
if make_Plot:
    plt.figure()
    plt.title(r'$q_{12}(\lambda)$-Plot')  # USE MATHEMATICAL EXPRESSIONS IN TITLE
    plt.plot(Lambda_Values, q12)
    plt.scatter(Lambda_Values, q12)
    # plt.axis([0, 6, 0, 20])
    plt.xlabel("$\lambda$")
    plt.ylabel("$q_{12}$")
    plt.legend()
    plt.show()

# #---------------------------------------------------------------
